package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgChannelRequest;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgChannelRequestWindowChange;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshMsgChannelRequestWindowChangeCodec
        implements SshMsgChannelRequestCodec.RequestCodec {

    @Override
    public SshMsgChannelRequest read(InputStream in, int recipientChannel, boolean wantReply)
            throws IOException {
        int terminalCharactersWidth = Uint32Codec.readValue(in);
        int terminalRowsHeight = Uint32Codec.readValue(in);
        int terminalPixelsWidth = Uint32Codec.readValue(in);
        int terminalPixelsHeight = Uint32Codec.readValue(in);

        return new SshMsgChannelRequestWindowChange(recipientChannel,
                                                    terminalCharactersWidth,
                                                    terminalRowsHeight,
                                                    terminalPixelsWidth,
                                                    terminalPixelsHeight);
    }

    @Override
    public void write(SshMsgChannelRequest value, OutputStream out)
            throws IOException {
        SshMsgChannelRequestWindowChange message = (SshMsgChannelRequestWindowChange) value;
        Uint32Codec.writeValue(message.terminalCharactersWidth, out);
        Uint32Codec.writeValue(message.terminalRowsHeight, out);
        Uint32Codec.writeValue(message.terminalPixelsWidth, out);
        Uint32Codec.writeValue(message.terminalPixelsHeight, out);
    }
}
